#coding: utf-8
import workflow
import Image, ImageOps, ImageFilter
import console
import clipboard
import datetime
from io import BytesIO
import urllib
import editor
import keychain
import pickle
import paramiko
import photos

#keychain.delete_password('rocketink', 'editorial')
login = keychain.get_password('rocketink_ssh', 'editorial')
if login is not None:
    user, pw = pickle.loads(login)
else:
    user, pw = console.login_alert('FTPS Login Needed', 'No login credentials found.')
    pickle_token = pickle.dumps((user, pw))
    keychain.set_password('rocketink_ssh', 'editorial', pickle_token)

width_selection = workflow.get_variable('widthSelection')
source_selection = workflow.get_variable('source')

host = "my.uberspace.de"
port = 22
url_base = "http://rocketink.net/uploads/"
remote_path = "~/Dropbox/rocketink/_src/uploads/"

if source_selection == 'photo':
    image_selection = photos.pick_image()
else:
    image_selection = clipboard.get_image()
    if not image_selection:
        console.alert('No Image', 'Clipboard does not contain an image')

today = datetime.datetime.now()

file_name = console.input_alert("Image Title", "Enter Image File Name")
file_name = today.strftime("%Y-%m-%d")+'_'+file_name +'.png'

date_path = today.strftime("%Y/%m/")
# Used to create full remote file path
remote_date_path =  remote_path + date_path

def customSize(img, new_width):
    w, h = img.size
    if w > new_width:
        wsize = float(new_width)/float(w)
        hsize = int(float(h)*float(wsize))
        img = img.resize((new_width, hsize), Image.ANTIALIAS)
        print str(new_width)+'w X '+str(hsize)+'h'
    else:
        print 'Image not resized. Width less than '+new_width
    return img

image = customSize(image_selection, int(width_selection))
image.show()

buffer = BytesIO()
image.save(buffer, 'PNG')
buffer.seek(0)

file_url = urllib.quote(file_name)

try:

    transport = paramiko.Transport((host, port))
    transport.connect(username=user, password=pw)
    sftp = paramiko.SFTPClient.from_transport(transport)
    #sftp.chdir(remote_path)
    f = sftp.open(remote_date_path+file_name, 'wb')
    f.write(buffer.read())
    f.close()

    sftp.close()
    transport.close()
    console.hud_alert(file_name + ' uploaded', 'success')

except Exception, e:
    print e
    console.alert('Error', e)

image_link = url_base+date_path+file_url
print(image_link)
clipboard.set(image_link)
console.hud_alert('Remote URL on Clipboard ', 'success')

# by Gabe Weatherhead
# modified by Patrick Welker
# Source: http://www.macdrifter.com/2013/09/editorial-workflow-for-sizing-and-uploading-images.html